/*
 * Filename:    NMAZZ.mq4
 * Author:      CaHbI4, based on the original by Tartan at the link below
 * Date:        Mar 14, 2006
 *
 * Description: 
 *
 * Version:     1.0
 *              Initial release
 *              http://www.arkworldmarket.ru/forum/showthread.php?t=966&page=108&pp=10
 */
 
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 BlueViolet
#property indicator_color2 Gold

//---- input parameters
extern int     depth=74;      //ZigZag params
extern int     deviation=5;   //ZigZag params
extern int     backstep=2;    //ZigZag params
extern int     per=50;        //period for CCI and WPR
extern int     ucci=200;      //CCI level
extern int     mwpr=-15;      //WPR low level
extern int     bwpr=-85;      //WPR high level
extern int     nBars=0;       //set 300 for backtest

//---- buffers
double ExtMapBuffer1[];
double RevPoint[];

//---- variables
double zz=0, zzold=0,fzz=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2,indicator_color1);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0, "MAZZ");
   
   SetIndexStyle(1,DRAW_ARROW,EMPTY,EMPTY,indicator_color2);
   SetIndexBuffer(1,RevPoint);
   SetIndexArrow(1, 161); //point symbol
   SetIndexLabel(1, "RevPoint");
   
   ObjectCreate("ZZ_txt",OBJ_TEXT,0,0,0);
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars = IndicatorCounted();
   //if( Bars <= sper) return(0);   
   if( counted_bars < 0) return(-1);
   if( counted_bars > 0) counted_bars--;   // last counted bar will be recounted
   
   int limit = Bars;
   for(int shift = limit; shift >= 0; shift--){
      if( zz!=0 && zz!=zzold) zzold=zz;
      double ccione=iCCI(NULL,0,per,PRICE_WEIGHTED,shift+2);
      double ccinul=iCCI(NULL,0,per,PRICE_WEIGHTED,shift+1);
      double wprone=iWPR(NULL,0,per,shift+2);
      double wprnul=iWPR(NULL,0,per,shift+1);
      
      zz=iCustom(NULL,0,"ZigZagE",depth,deviation,backstep,nBars,0,shift+2);
      double sig=0;
      if( zz!=0) fzz=zz; 
      if( zz!=0 && ( ((ccione<-ucci || ccinul<-ucci) && (wprone<bwpr || wprnul<bwpr)) || 
              ((ccione>ucci || ccinul>ucci) && (wprone>mwpr || wprnul>mwpr))) ) sig=1; else sig=0;
      if( sig==1)
         RevPoint[shift]=zz;
      else
         RevPoint[shift]=sig;
      if( zz==0) fzz=zzold;
      if( zz!=0){
         ObjectSetText("ZZ_txt", "ZZ="+DoubleToStr(zz,4),8,"Arial",White);
         if( zz>Close[0]) ObjectMove("ZZ_txt",0,Time[0],zz+5*Point);
         if( zz<Close[0]) ObjectMove("ZZ_txt",0,Time[0],zz-5*Point);
      }
      ExtMapBuffer1[shift]=fzz;
   }
   
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete("ZZ_txt");
}
//+------------------------------------------------------------------+

